



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQLServer通过链接服务器远程删除数据性能问题解决</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQLServer通过链接服务器远程删除数据性能问题解决</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 18:59:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文:<a href="http://www.cnblogs.com/JentleWang/p/3643408.html" rel="external nofollow noreferrer">SQLServer通过链接服务器远程删除数据性能问题解决</a>
<p>在上一遍文章中介绍了<a href="http://www.cnblogs.com/captainjack/p/3621628.html" rel="external nofollow noreferrer">SQLServer通过链接服务器访问Oracle性能问题的解决方法</a>，本文介绍链接服务器下远程删除SQLServer数据的性能问题解决</p>
<h1>1. 问题发现</h1>
<p>系统中有个功能，需要远程删除SQLServer实例的表数据，删除语句中有where条件，条件中有一个子查询。</p>
<p>该功能前台执行速度非常慢。所以准备调优。</p>
<p>下面为演示代码，未优化前如下：</p>
<div>
<pre class="prettyprint linenums">DELETE<br />
FROM [LINKSERVERNAME].[AdventureWorks2008].[Sales].[SalesOrderDetail]<br />
WHERE SalesOrderDetailID=5<br />
    AND EXISTS(SELECT TOP 1 1 FROM [LINKSERVERNAME].[AdventureWorks2008].[Sales].[SalesOrderDetail])</pre>
</div>
<p>　　此时的执行计划如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/88922/201404/031627034214936.png"></p>
<p>可以看到执行计划存在一个远程扫描，然后在本地执行筛选。</p>
<p>在远程服务器开启profiler跟踪，部分内容如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/88922/201404/031630574844161.png"></p>
<p>可以看到远程服务器开启了一个游标，然后逐行读取数据并返回给调用端。</p>
<p>可以预见性能会非常差，如何避免不带where条件的远程扫描呢？</p>
<h1>2. 问题解决</h1>
<h2>2.1 OpenQuery</h2>
<p>使用OpenQuery将delete数据的筛选提交到远程服务器执行。</p>
<div>
<pre class="prettyprint linenums">DELETE<br />
FROM OPENQUERY([LINKSERVERNAME]<br />
    ,'SELECT *<br />
FROM [AdventureWorks2008].[Sales].[SalesOrderDetail]<br />
WHERE SalesOrderDetailID=5<br />
    AND EXISTS(SELECT TOP 1 1 FROM [AdventureWorks2008].[Sales].[SalesOrderDetail])'<br />
)</pre>
</div>
<p>此时，执行计划如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/88922/201404/031638069682686.png"></p>
<h2>2.2&nbsp;sp_executesql</h2>
<p>将整个delete语句提交到远程执行</p>
<div>
<pre class="prettyprint linenums">DECLARE @sql nvarchar(max)<br />
SELECT @sql ='<br />
DELETE<br />
FROM [AdventureWorks2008].[Sales].[SalesOrderDetail]<br />
WHERE SalesOrderDetailID=5<br />
    AND EXISTS(SELECT TOP 1 1 FROM [AdventureWorks2008].[Sales].[SalesOrderDetail])<br />
'<br />
exec [LINKSERVERNAME].[AdventureWorks2008].dbo.sp_executesql @sql</pre>
</div>
<p>profiler跟踪到的语句如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/88922/201404/031642284531434.png"></p>
<p>如有不对的地方，欢迎拍砖；如有其他方法，求分享，谢谢！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mvw468.html">Keepalived高可用集群介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/4956vr68.html">Windows下进程间通信及数据共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmn7019.html">C&plus;&plus;11常量表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgzn2q.html">&dollar;&lbrace;var&rcub;变量替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1g54g8.html">WCF简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mny512q.html">fedora 安装chrome</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xlprw9.html">C&num;下如何用NPlot绘制期货股票K线图&lpar;2&rpar;&colon;读取数据文件让K线图自动更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xlr7g9.html">Codeforces Round &num;198 &lpar;Div&period; 2&rpar; &mdash;&mdash; C</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy142oxq.html">Charles从入门到精通</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg06n78.html">loadrunner：Auto Correlate自动定位瓶颈</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mer0erq.html">redis数据类型及常用命令介绍（图文实例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdo4w49.html">【转】javascript 分号问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzyzlw8.html">java SSM 解决跨域问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzyw7l8.html">JavaScript笔记1&mdash;&mdash;&mdash;js的一些常识</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyv50q.html">DS-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1y0xxq.html">double保留两位小数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxmd79.html">CentOS 6&period;5静态IP的设置（NAT和桥接联网方式都适用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pmv5q.html">Diocp截图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwr46k8.html">MySQL Transaction--事务无法正常回滚导致的异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gppzl79.html">Overview &amp;amp&semi; PPT 类型 &amp;amp&semi; PPT 制作流程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9geev2z8.html">由Java代码运行shell命令&sol;脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkkvnv8.html">java&plus;js实现完整的图片展示本地目录demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rggv348.html">SQL Server 2012 复制（发布订阅的研究）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddll49.html">Java流</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zz6oj9.html">JavaScript阻止事件冒泡（兼容IE、Chrome、FF）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zz4g19.html">hdu 4911 Inversion（找到的倒数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meego0q.html">ubuntu12&period;04下一个samba、tftp、nfs构造</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkdwlv8.html">怎样用OleDbDataAdapter来对数据库进行操作？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j5d4o8.html">HTML5分析实战Web存储机制&lpar;Web Storage&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ywomw8.html">Chapter 2 User Authentication&comma; Authorization&comma; and Security（3）：保server避免暴力袭击</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
